package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.interactions.Actions;

public class ElaboracaoCardapioPMEPage extends PageBase {
    //Mapping
    By ClicarMenu = By.xpath("//i[@class='v-icon notranslate mdi mdi-menu theme--light']");
    By CampodePesquisa = By.id("menuSearchInput");
    By ClicarnaElaboracaoCardapio = By.xpath("//*[@class='v-list-item__title']");

    By TipodeCardapioButton = By.id("typeMenu");
    By SelecionarTipoCardapio = By.xpath("//div[text()='0000000001 - ALMOÇO']");
    By ServicoButton = By.id("service");
    By SelecionarServico = By.xpath("//div[text()='00004 - RETIRADA AUTOMATICA']");
    By CampoDataInicio = By.xpath("//input[@id='initialDate']");
    By CampoDataFim = By.xpath("//input[@id='finalDate']");
    By CampoDescricao = By.id("describeCard");
    By ClicarCarregaCardapio = By.id("generateMenu");
    By CardapioCriado = By.xpath("//div[@id='titleHeader']");

    By LupaSelecionarCardapio = By.id("searchButton");
    By SelecionarUmCardapio = By.xpath("//span[text()='28/02/2023']");

    By SetaQueMudaVisualizacaoCard = By.xpath("//*[@class='v-icon notranslate mdi mdi-swap-horizontal theme--light']");
    By Visualizacao1 = By.id("firstPreview");
    By Visualizacao2 = By.id("secondPreview");
    By Visualizacao3 = By.id("thirdPreview");

    By CampodeComensais = By.xpath("//div[@id='rowCardapio']//div[@class='fixed-cols left']/div[2]/div[1]/span");
    By EditarComensaisField = By.xpath("//input[@id='QTCLIESTCPME_editable_0002']");
    By CampoSalvarEdicao = By.id("saveEdit");
    By CampodoCardapio = By.xpath("//div[@id='platesContainer']/div[1]/div[1]/span");
    By SelecionarPratoCardapio = By.xpath("//span[text()='00.00.00.000 | STROGONOV DE FRUTOS DO MAR']");
    By EditarComensaisPrato = By.xpath("//input[@id='numberDiners']");
    By Selecionardiasemana1 = By.xpath("//form[@id=\"formPlate\"]//div[@class=\"zd-checkbox-horizontal\"]/div[1]//div[@class=\"v-input--selection-controls__ripple\"]");
    By CampoSalvarPratoCardapio = By.id("saveModal");

    By SelecionarPratoASerExcluido = By.xpath("//span[text()='STROGONOV DE FRUTOS DO MAR']");
    By IconeExclusaoPeriodo = By.xpath("//*[@class='v-icon notranslate mdi mdi-delete theme--light']");
    By DataInicialPeriodo = By.xpath("//input[@id='initialDateExclude']");
    By DataFimPeriodo = By.xpath("//input[@id='finalDateExclude']");
    By BotaoExcluir = By.xpath("//*[@id='excludeButton']");
    By BotaoConfirmarExclusao = By.xpath("//*[@id='yesButtonExclude']");
    By ConfirmacaodeExclusao = By.xpath("//span[text()='Excluído com sucesso!']");

    By IconeImportarCardDia = By.xpath("//*[@class='v-icon notranslate mdi mdi-import theme--light']");
    By CampoTipoCardapio = By.xpath("//input[@id='TipoCardImportCarDia']");
    By CampoSelecionarTipoCardapio = By.xpath("//div[@id=\"list-item-848-1\"]//div[text() = '0000000002 - DESJEJUM']");
    By CampoServico = By.xpath("//input[@id='servicoImportCarDia']");
    By CampoSelecionarServico = By.xpath("//div[@id='list-item-853-0']");
    By LupaSelecionarPeriodo = By.xpath("//*[@id='SEARCHBUTTON']");
    By SelecionarPeriodo = By.xpath("//span[text()='31/12/2022']");
    By CampoParaInformarDataInicio = By.xpath("//input[@id='DtDeCarDia']");
    By CampoParaInformarDataFim = By.xpath("//input[@id='DtAteCarDia']");
    By SelecionarOpcaoSobrepor = By.xpath("//label[text()='Sobrepor']");
    By CampoAlterarComensais = By.xpath("//input[@id='arredondarComen']");
    By CampoSelecionarDePara = By.xpath("//span[text()='07/12/2022 quarta-feira']");
    By CampoDeSalvar = By.xpath("//*[@id='saveImpCardDia']");
    By CampoDePratoPreenchido = By.xpath("//span[text()='STROGONOV DE FRUTOS DO MAR']");

    By CampoUnidadeAgregada = By.xpath("//input[@id='aggregated']");
    By SelecionarUnidadeAgregada = By.xpath("//div[text()='0002 - DEPOSITO JABAQUARA']");
    By ExibirCustosComBaseNaCentral = By.xpath("//input[@id='input-350']");


    By IconeConfiguracoes = By.xpath("//*[@id='configCard']");
    By AdicionarTipodePrato = By.xpath("//i[@class='v-icon notranslate mdi mdi-plus theme--light']");
    By CampoParaInformarTipoDePrato = By.xpath("//td[@class='zd-table-cell text-left zd-table-cell-editable']");
    By SelecionarTipodePrato = By.xpath("//div[text()='05 - SOBREMESA']");
    By SalvarTipodePratoAdd = By.xpath("//button[@id='saveButton']");
    By SelecionarTipodePratoExcluir = By.xpath("//form[@id=\"formDragGrid\"]//div[@class=\"v-data-table__wrapper\"]/table/tbody/tr[4]//td[@class=\"zd-table-cell selectable\"]//div[@class=\"v-input--selection-controls__ripple\"]");
    By ExcluirTipodePrato = By.xpath("//i[@class='v-icon notranslate mdi mdi-trash-can-outline theme--light']");
    By ConfirmarExclusao = By.xpath("//*[@id='yes']");
    By AbaImportacaoPorTipodePrato = By.xpath("//div[@id='tabConfigCard-tab-1']");
    By CampoTipoCardapioImportacao = By.xpath("//form[@id='formFilterImportTpPrato']//div[@aria-owns=\"list-799\"]");
    By SelecionarTipoCardapioImportacao = By.xpath("//div[@id='list-item-1041-0']");
    By CampoServicoImportacao = By.xpath("//div[@class='v-input__control']//div[@aria-owns=\"list-805\"]");
    By SelecionarServicoImportacao = By.xpath("//div[@id='list-item-1051-0']");
    By LupaSelecionarPeriod = By.xpath("//*[@id='SEARCHBUTTON']");
    By SelecionarPeriodo1 = By.xpath("//span[text()='31/12/2022']");
    By CampoIncluirCardapioaPartir = By.xpath("//div[@id='INCLUIRCARD']");
    By CampoSelecionarTipodePrato = By.xpath("//div[@id=\"gridImportacaoTpPrato\"]//div[@class=\"v-data-table__wrapper\"]/table/tbody/tr[4]//div[@class=\"v-input--selection-controls__ripple\"]");
    By CampodeSalvarInclusao = By.xpath("//button[@id=\"salvar\"]");

    By IconeEmissoes = By.xpath("//button[@id='activatorDropDown']");
    By EmissaoCardpDia = By.xpath("//div[@id='cardDia']");
    By BotaoPDFRelat = By.xpath("//button[@id='pdf']");
    By EmissaoCardpSemana = By.xpath("//div[@id='cardSemana']");
    By EmissaoCardpPeriodo = By.xpath("//div[@id='cardPeriodo']");

    By IconeAtualizarComensais = By.xpath("//button[@id='updateComen']");
    By CampoInformarAgregada = By.xpath("//form[@id='FORM']//div[@aria-owns=\"list-1076\"]");
    By CampoSelecionarAgregada = By.xpath("//div[@id='list-1076']//div[@class='v-list-item__title']");

    By IconeAcompanhamentodeCusto = By.xpath("//button[@id='acompCust']");
    By AtualizarCustoAutomaticamente = By.xpath("//label[text()='Atualizar custo automaticamente']");
    By IconeGraficos = By.xpath("//button[@id='showChart']");
    By FecharJanela = By.xpath("//button[@id='closeWindow']");

    By IconeAnalisedeCusto = By.xpath("//button[@id='analiseCusto']");
    By IconedeTelaCheia = By.xpath("//button[@id='fullscreenModal']");
    By AbaMateriaPrima = By.xpath("//div[@id='allTabs-tab-1']");
    By ClicarAbaAgregada = By.xpath("//div[@id='tabMateriaPrima-tab-1']");
    By ClicarParaFecharModal = By.xpath("//button[@id='closeModalButton']");

    By IconeRankingDePratos = By.xpath("//button[@id='PlateRanking']");
    By ClicarSobPrato = By.xpath("//span[text()='CAMARÃO NA CHAMPAGNE']");
    By CampoPratoInicial = By.xpath("//input[@id='initialPlate']");
    By SelecionarPratoInicial = By.xpath("//div[text()='00 | PRINCIPAL']");
    By CampoPratoFinal = By.xpath("//input[@id='finalPlate']");
    By SelecionarPratoFinal = By.xpath("//div[@id='list-item-897-0']//div[text()='00 | PRINCIPAL']");
    By ClicarSalvar = By.xpath("//button[@id='saveButton']");

    By IconeAnaliseNutricional = By.xpath("//button[@id='AnalNutr']");
    By CampoInformarData = By.xpath("//input[@id=\"dateNutr\"]");
    By SelecionarData = By.xpath("//div[text()='01/12/2022 qui']");
    By ClicarParaFechar = By.xpath("//button[@id='closeModalButton']");

    By IconeAnalisedeCores = By.xpath("//i[@class='v-icon notranslate mdi mdi-palette theme--light']");


    By IconeCopiaPratoeComensais = By.xpath("//button[@id='copiaPratoEComensais']");
    By SelecionarOpcaoComensaisdoPrato = By.xpath("//label[text()='Comensais do Prato']");
    By SelecionarOsComensais = By.xpath("//div[@id='textComensaisDoPrato']");
    By SobreporPratosInformados = By.xpath("//label[text()='Sobrepor Pratos já informados']");
    By ClicarnaOpcaoExcecao = By.xpath("//div[@class='v-list-item__title zd-list-item-title']");
    By Selecionardiadasemana = By.xpath("//label[text()='Segunda-feira']");
    By InformarComensaisdeExcessao = By.xpath("//div[@id='textComensaisDoPrato1']");
    By AbaComensais = By.xpath("//div[@id='tabsPratoEComensais-tab-1']");
    By ClicaremConfirmar = By.xpath("//button[@id='confirmarCopia']");



    //Actions
    public void AcessarTela() {
        tempo();
        click(ClicarMenu);
        sendKeys(CampodePesquisa, "Elaboração do Cardápio");
        tempo();
        click(ClicarnaElaboracaoCardapio);
    }

    public void Preenchercamposfiltro(String datainicio, String datafim, String descricaocarp) {
        tempo();
        click(TipodeCardapioButton);
        click(TipodeCardapioButton);
        tempo();
        click(SelecionarTipoCardapio);
        click(ServicoButton);
        click(SelecionarServico);
        tempo();
        click(CampoDataInicio);
        sendKeys(CampoDataInicio, datainicio);
        click(CampoDataFim);
        sendKeys(CampoDataFim, datafim);
        click(CampoDescricao);
        sendKeys(CampoDescricao, descricaocarp);
        click(ClicarCarregaCardapio);
    }

    public String RetornaMsgCardapioCriado() {
        return getText(CardapioCriado);
    }

    public void CardapioAgregada() {
        tempo();
        click(TipodeCardapioButton);
        click(TipodeCardapioButton);
        tempo();
        click(SelecionarTipoCardapio);
        click(ServicoButton);
        click(SelecionarServico);
        tempo();
        click(LupaSelecionarCardapio);
        tempo();
        click(SelecionarUmCardapio);
        click(CampoUnidadeAgregada);
        click(SelecionarUnidadeAgregada);
        tempo();
        click(ExibirCustosComBaseNaCentral);
        click(ClicarCarregaCardapio);
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }


    public void SelecionarCardapioJaCriado() {
        click(TipodeCardapioButton);
        click(TipodeCardapioButton);
        tempo();
        click(SelecionarTipoCardapio);
        click(ServicoButton);
        click(SelecionarServico);
        tempo();
        click(LupaSelecionarCardapio);
        tempo();
        click(SelecionarUmCardapio);
        click(ClicarCarregaCardapio);
        try {
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }
    }

    public void AlterarComensais() {
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(CampodeComensais)).doubleClick().build().perform();
        tempo();
        click(CampoSalvarEdicao);
    }

    public void AdicionarPrato(String comensais) {
        tempo();
        Actions actions = new Actions(driver);
        actions.moveToElement(driver.findElement(CampodoCardapio)).doubleClick().build().perform();
        tempo();
        click(SelecionarPratoCardapio);
        click(EditarComensaisPrato);
        sendKeys(EditarComensaisPrato, comensais);
        tempo();
        click(Selecionardiasemana1);
        tempo();
        click(CampoSalvarPratoCardapio);
    }

    public String VerificarsePratoFoiAdicionado() {
        return getText(CampoDePratoPreenchido);
    }

    public void ExcluirPratopeloPeriodo() {
        click(SelecionarPratoASerExcluido);
        click(IconeExclusaoPeriodo);
        tempo();
        click(BotaoExcluir);
        click(BotaoConfirmarExclusao);
        tempo();
    }

    public String ConfirmacaodeExclusao() {
        return getText(ConfirmacaodeExclusao);
    }

    public void ImportarCardpDia(String comens) {
        click(IconeImportarCardDia);
        click(CampoTipoCardapio);
        tempo();
        click(CampoSelecionarTipoCardapio);
        click(CampoServico);
        tempo();
        click(CampoSelecionarServico);
        click(LupaSelecionarPeriodo);
        click(SelecionarPeriodo);
        click(SelecionarOpcaoSobrepor);
        click(CampoAlterarComensais);
        sendKeys(CampoAlterarComensais, comens);
        click(CampoSelecionarDePara);
        click(CampoDeSalvar);
    }

    public void AdicionarPratoConfigCardapio() {
        click(IconeConfiguracoes);
        click(AdicionarTipodePrato);
        tempo();
        click(CampoParaInformarTipoDePrato);
        tempo();
        click(SelecionarTipodePrato);
        click(SalvarTipodePratoAdd);
    }

    public void ExcluirPratoConfigCardapio() {
        tempo();
        click(IconeConfiguracoes);
        click(SelecionarTipodePratoExcluir);
        click(ExcluirTipodePrato);
        click(ConfirmarExclusao);
        tempo();
    }

    public void AbaImportacaoPorTipodeCardapio(String DataIncluirCard) {
        tempo();
        click(IconeConfiguracoes);
        click(AbaImportacaoPorTipodePrato);
        tempo();
        click(CampoTipoCardapioImportacao);
        tempo();
        click(SelecionarTipoCardapioImportacao);
        click(CampoServicoImportacao);
        click(SelecionarServicoImportacao);
        click(LupaSelecionarPeriod);
        click(SelecionarPeriodo1);
        click(CampoIncluirCardapioaPartir);
        clear(CampoIncluirCardapioaPartir);
        sendKeys(CampoIncluirCardapioaPartir, DataIncluirCard);
        click(CampoSelecionarTipodePrato);
        click(CampodeSalvarInclusao);

    }

    public void EmissaoCardapioDia() {
        tempo();
        click(IconeEmissoes);
        tempo();
        click(EmissaoCardpDia);
        tempo();
        click(BotaoPDFRelat);
        tempo();
        tempo();
    }

    public void EmissaoCardapioSemana() {
        tempo();
        click(IconeEmissoes);
        tempo();
        click(EmissaoCardpSemana);
        tempo();
        click(BotaoPDFRelat);
        tempo();
        tempo();
    }

    public void EmissaoCardapioPeriodo() {
        tempo();
        click(IconeEmissoes);
        tempo();
        click(EmissaoCardpPeriodo);
        tempo();
        click(BotaoPDFRelat);
        tempo();
        tempo();
    }

    public void AtualizarComensais() {
        tempo();
        click(IconeAtualizarComensais);
        tempo();
        click(CampoInformarAgregada);
        click(CampoSelecionarAgregada);

    }

    public void AcompanhamentodeCustos() {
        tempo();
        click(IconeAcompanhamentodeCusto);
        tempo();
        click(AtualizarCustoAutomaticamente);
        click(IconeGraficos);
        tempo();
        click(FecharJanela);
    }

    public void AnaliseDeCusto() {
        tempo();
        click(IconeAnalisedeCusto);
        tempo();
        click(IconedeTelaCheia);
        tempo();
        tempo();
        click(AbaMateriaPrima);
        tempo();
        tempo();
        click(ClicarAbaAgregada);
        click(ClicarParaFecharModal);
    }

    public void RankingdePratos() {
        tempo();
        click(ClicarSobPrato);
        click(IconeRankingDePratos);
        click(CampoPratoInicial);
        click(SelecionarPratoInicial);
        tempo();
        click(CampoPratoFinal);
        click(SelecionarPratoFinal);
        tempo();
        click(ClicarSalvar);

    }

    public void AcessarAnaliseNutricional() {
        tempo();
        click(IconeAnaliseNutricional);
        tempo();
        click(CampoInformarData);
        click(SelecionarData);
        tempo();
        click(ClicarParaFechar);
        tempo();
    }
    public void CopiarPratoeComensais(){
        tempo();
        click(IconeCopiaPratoeComensais);
        click(SelecionarOpcaoComensaisdoPrato);
        tempo();
        click(SelecionarOsComensais);
        tempo();
        click(SobreporPratosInformados);
        click(ClicarnaOpcaoExcecao);
        click(Selecionardiadasemana);
        click(InformarComensaisdeExcessao);
        click(AbaComensais);
        click(ClicaremConfirmar);
        tempo();
    }

    public void AnalisedeCores(){
        tempo();
        click(IconeAnalisedeCores);
        tempo();
    }
}
